{ pkgs, ... }:
{
  # Bootloader.
  boot.loader.systemd-boot.enable = true;
  boot.loader.efi.canTouchEfiVariables = true;

  # Enable networking
  networking.networkmanager.enable = true;

  # setup magicdns for tailscale
  networking.nameservers = [ "100.100.100.100" "1.1.1.1" "8.8.8.8" ];
  networking.search = [ "hummingbird-stork.ts.net" ];

  # Set your time zone.
  time.timeZone = "Europe/Paris";

  # Select internationalisation properties.
  i18n.defaultLocale = "en_US.UTF-8";

  i18n.extraLocaleSettings = {
    LC_ADDRESS = "fr_FR.UTF-8";
    LC_IDENTIFICATION = "fr_FR.UTF-8";
    LC_MEASUREMENT = "fr_FR.UTF-8";
    LC_MONETARY = "fr_FR.UTF-8";
    LC_NAME = "fr_FR.UTF-8";
    LC_NUMERIC = "fr_FR.UTF-8";
    LC_PAPER = "fr_FR.UTF-8";
    LC_TELEPHONE = "fr_FR.UTF-8";
    LC_TIME = "fr_FR.UTF-8";
  };

  # Enable the X11 windowing system.
  # You can disable this if you're only using the Wayland session.
  services.xserver.enable = true;

  # Enable the KDE Plasma Desktop Environment.
  services.displayManager.sddm.enable = true;
  services.desktopManager.plasma6.enable = true;

  # does this add river to sddm menu?
  programs.river.enable = true;

  # Configure keymap in X11
  services.xserver = {
    xkb = {
      layout = "fr";
      variant = "";
      options = "ctrl:nocaps";
    };
  };

  # Configure console keymap
  console.keyMap = "fr";

  # Enable CUPS to print documents.
  services.printing.enable = true;

  # Enable sound with pipewire.
  hardware.pulseaudio.enable = false;
  security.rtkit.enable = true;
  services.pipewire = {
    enable = true;
    alsa.enable = true;
    alsa.support32Bit = true;
    pulse.enable = true;
    # If you want to use JACK applications, uncomment this
    #jack.enable = true;

    # use the example session manager (no others are packaged yet so this is enabled by default,
    # no need to redefine it in your config for now)
    #media-session.enable = true;
  };

  # Enable touchpad support (enabled default in most desktopManager).
  # services.xserver.libinput.enable = true;

  # Define a user account. Don't forget to set a password with ‘passwd’.
  users.users.khais = {
    createHome = true;
    initialPassword = "asunarovow";
    isNormalUser = true;
    description = "Khaïs COLIN";
    extraGroups = [ "networkmanager" "wheel" "podman" "libvirtd" ];
    shell = pkgs.zsh;
  };

  users.users.guest = {
    createHome = true;
    isNormalUser = true;
    description = "Guest Account";
    extraGroups = [ "networkmanager" ];
    shell = pkgs.zsh;
    packages = with pkgs; [
      mpv
      vlc
    ];
  };

  # Install firefox.
  programs.firefox.enable = true;

  # chroot jail
  programs.firejail.enable = true;

  # shell
  programs.zsh.enable = true;

  # Allow unfree packages
  nixpkgs.config.allowUnfree = true;

  # List packages installed in system profile. To search, run:
  # $ nix search wget
  environment.systemPackages = with pkgs; [
    neovim
    home-manager
    git
    gnumake
    cifs-utils
    tailscale
    wluma
    # man pages
    man-pages man-pages-posix
    # kde
    kdePackages.kate kdePackages.plasma-workspace kdePackages.dolphin
    # fix kde apps having no icons
    kdePackages.qtsvg
    thunderbird-128
  ];

  # set user environment variables
  environment.sessionVariables = {
    # I don't know what this does, but it is needed for wluma to work correctly.
    # It will also slightly increase cpu usage (on wayland compositors), but shouldn't be too bad.
    WLR_DRM_NO_MODIFIERS = 1;
    # fix dolphin file associations not working
    XDG_MENU_PREFIX = "plasma-";
    # fix cursor size for some apps
    XCURSOR_SIZE = 24;
  };

  # Some programs need SUID wrappers, can be configured further or are
  # started in user sessions.
  # programs.mtr.enable = true;
  # programs.gnupg.agent = {
  #   enable = true;
  #   enableSSHSupport = true;
  # };

  # font configuration
  fonts = {
    packages = with pkgs; [
      nerdfonts
      ibm-plex
      cm_unicode
    ];
    fontconfig = {
      defaultFonts = {
        monospace = [ "VictorMono NF Medium" ];
        sansSerif = [ "IBM Plex Sans" ];
        serif = [ "CMU Serif" ];
      };
    };
  };

  services.tailscale = {
    enable = true;
    useRoutingFeatures = "both";
    extraUpFlags = [ "--ssh" ];
  };

  # enable wluma for automatic brightness adjustment
  systemd.user.services.wluma = {
    enable = true;
    description = "Adjusting screen brightness based on screen contents and amount of ambient light";
    after = [ "graphical-session.target" ];
    partOf = [ "graphical-session.target" ];
    serviceConfig = {
      ExecStart = "${pkgs.wluma}/bin/wluma";
      Restart = "always";
    };
    wantedBy = [ "graphical-session.target" ];
  };

  programs.gnupg.agent = {
    enable = true;
    enableSSHSupport = true;
  };

  # Enable the OpenSSH daemon.
  services.openssh.enable = true;

  # enable manpages documentation
  documentation = {
    man = {
      enable = true;
      generateCaches = true;
    };
    info.enable = true;
    dev.enable = true; # linux man-pages project, dev documenation
  };

  # enable docker virtualization
  virtualisation.podman = {
    enable = true;
    # create alias mapping docker to podman
    dockerCompat = true;
    dockerSocket.enable = true;
  };

  # enable hardware acceleration for qemu
  virtualisation.libvirtd.enable = true;
  programs.virt-manager.enable = true;

  # This value determines the NixOS release from which the default
  # settings for stateful data, like file locations and database versions
  # on your system were taken. It‘s perfectly fine and recommended to leave
  # this value at the release version of the first install of this system.
  # Before changing this value read the documentation for this option
  # (e.g. man configuration.nix or on https://nixos.org/nixos/options.html).
  system.stateVersion = "24.05"; # Did you read the comment?

  # flakes
  nix.settings.experimental-features = [ "nix-command" "flakes" ];

  # automatically collect garbage
  nix.gc = {
    automatic = true;
    dates = "weekly";
    options = "--delete-older-than 60d";
  };
}
